Imports System.Text

Public Class Form1

    ' vendor and product IDs
    Private Const VendorID As Integer = &H1234    'Replace with your device's
    Private Const ProductID As Integer = &H1      'product and vendor IDs

    ' read and write buffers
    Private Const BufferInSize As Integer = 64 'Size of the data buffer coming IN to the PC
    Private Const BufferOutSize As Integer = 65    'Size of the data buffer going OUT from the PC
    Dim BufferIn(BufferInSize) As Byte          'Received data will be stored here - the first byte in the array is unused
    Dim BufferOut(BufferOutSize) As Byte    'Transmitted data is stored here - the first item in the array must be 0
    Private _hidGetVendorID As Integer

    Private Property hidGetVendorID(ByVal pHandle As Integer) As Integer
        Get
            Return _hidGetVendorID
        End Get
        Set(ByVal value As Integer)
            _hidGetVendorID = value
        End Set
    End Property

    Public Function AsciiByteToChar(ByVal b As Byte) As Char

        Dim barr() As Byte = New Byte() {b}

        Dim carr() As Char = Encoding.ASCII.GetChars(barr)

        Return carr(0)

    End Function


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ConnectToHID(Me)
    End Sub

    Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        DisconnectFromHID()
    End Sub

    ' a HID device has been plugged in...********
    Public Sub OnPlugged(ByVal pHandle As Integer)
        If hidGetVendorID(pHandle) = VendorID And hidGetProductID(pHandle) = ProductID Then
            MsgBox("Device connected", vbOKOnly, "USB")
        End If
    End Sub

    '*****************************************************************
    ' a HID device has been unplugged...
    '*****************************************************************
    Public Sub OnUnplugged(ByVal pHandle As Integer)
        If hidGetVendorID(pHandle) = VendorID And hidGetProductID(pHandle) = ProductID Then
            hidSetReadNotify(hidGetHandle(VendorID, ProductID), False)
            MsgBox("Device unplugged", vbOKOnly, "USB")
        End If
    End Sub

    '*****************************************************************
    ' controller changed notification - called
    ' after ALL HID devices are plugged or unplugged
    '*****************************************************************
    Public Sub OnChanged()
        ' get the handle of the device we are interested in, then set
        ' its read notify flag to true - this ensures you get a read
        ' notification message when there is some data to read...
        Dim pHandle As Integer
        pHandle = hidGetHandle(VendorID, ProductID)
        hidSetReadNotify(hidGetHandle(VendorID, ProductID), True)
    End Sub

    '*****************************************************************
    ' on read event...
    '*****************************************************************
    Public Sub OnRead(ByVal pHandle As Integer)
        Dim S As String
        S = ""
        If hidRead(pHandle, BufferIn(0)) Then
            For i = 1 To 64
                S += AsciiByteToChar(BufferIn(i))
            Next
            TextBox2.Text = S
        End If
    End Sub

    Public Shared Function StrToByteArray(ByVal str As String) As Byte()
        Dim encoding As New System.Text.UTF8Encoding()
        Return encoding.GetBytes(str)
    End Function 'StrToByteArray

    Private Sub Send_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim i = 0
        BufferOut(0) = 0
        Dim k = TextBox1.Text.Length
        Dim datatosend As Byte() = StrToByteArray(TextBox1.Text)
        For i = 0 To k - 1
            BufferOut(i + 1) = datatosend(i)
        Next
        hidWriteEx(VendorID, ProductID, BufferOut(0))
    End Sub

    Private Sub hidWriteEx(ByVal VendorID As Integer, ByVal ProductID As Integer, ByVal BufferOut As Byte)
        Throw New NotImplementedException
    End Sub

    Private Function hidRead(ByVal pHandle As Integer, ByVal BufferIn As Byte) As Boolean
        Throw New NotImplementedException
    End Function

    Private Function hidGetHandle(ByVal VendorID As Integer, ByVal ProductID As Integer) As Integer
        Throw New NotImplementedException
    End Function

    Private Sub hidSetReadNotify(ByVal p1 As Integer, ByVal p2 As Boolean)
        Throw New NotImplementedException
    End Sub

    Private Function hidGetProductID(ByVal pHandle As Integer) As Integer
        Throw New NotImplementedException
    End Function

    Private Sub ConnectToHID(ByVal form1 As Form1)
        Throw New NotImplementedException
    End Sub

    Private Sub DisconnectFromHID()
        Throw New NotImplementedException
    End Sub

End Class
